<?php

// No direct access
defined('_JEXEC') or die;

class plgAuthenticationSber_id extends JPlugin
{
	/**
	 * This method should handle any authentication and report back to the subject
	 *
	 * @access	public
	 * @param	array	Array holding the user credentials
	 * @param	array	Array of extra options
	 * @param	object	Authentication response object
	 * @return	boolean
	 * @since 1.5
	 */
	
	function onUserAuthenticate($credentials, $options, &$response)
	{


		if (empty($credentials['password']))
		{
			$response->status = JAuthentication::STATUS_FAILURE;
			$response->error_message = JText::_('JGLOBAL_AUTH_EMPTY_PASS_NOT_ALLOWED');
			return false;
		}
		
		$joomlaUserId = $this->getJoomlaUserId($credentials);
		
		if(!$joomlaUserId) {
			return false;
		}

		$sberidUser = $this->getSberidUser($joomlaUserId);
		
		if(!$sberidUser) {
			return false;
		}


		$sberidUserPassword = $this->generatePassword($sberidUser[0]->sub);

		if($sberidUserPassword === $credentials['password']) {
			$response->status = JAuthentication::STATUS_SUCCESS;
			$response->error_message = '';
			return true;
		} else {
			return false;
		}

	}

	private function getJoomlaUserId($credentials) {
		// Get a database object
		$db	= JFactory::getDbo();
		$query = $db->getQuery(true);

		$query->select('id')
			->from('#__users')
			->where('username=' . $db->quote($credentials['username']));
		return $db->setQuery($query,0,1)->loadResult();		
	}

	private function getSberidUser($user_id) {
		// Get a database object
		$db	= JFactory::getDbo();
		$query = $db->getQuery(true);

		$query->select($db->quoteName(array('user_id', 'email', 'phone','sub','aud','linked_account_id')))
			->from('#__sber_id_users')
			->where('linked_account_id=' . $db->quote($user_id));
		return $db->setQuery($query)->loadObjectList();		
	}

	private function generatePassword($value) {
		$salt = '2fdsF-23r2-5432';
		return md5($salt.$value);
	}

}
