<?php
/**
 * СБЕР ID
 *
 * @version 	1.2.0
 * @author		СБЕР ID
 * @copyright	© 2020. All rights reserved.
 * @license 	GNU/GPL v.3 or later.
 */

// No direct access.
defined('_JEXEC') or die('(@)|(@)');
  if($options['button_size'] == 'MEDIUM') {
    $button_size = 'default';
  }
  else if($options['button_size'] == 'SMALL') {
    $button_size = 'small';
  } 
  else if($options['button_size'] == 'LARGE') {
    $button_size = 'long';
  }

  $button_type = 'default';

  if($options['button_style'] == 'FLAT') {
    $button_theme = 'default';
  }
  else if($options['button_style'] == 'BORDER') {
    $button_theme = 'white';
  }
?>
<noindex>
<div class="sber-id-container-<?=$sberbank_auth_params['nonce'];?>"></div>
<script>

  document.addEventListener("DOMContentLoaded", function() {
    (function () {
      const oidcParams = {
        response_type: 'code',
        client_type: 'PRIVATE',
        client_id: '<?=$sberbank_auth_params['client_id'];?>',
        redirect_uri: '<?=$sberbank_auth_params['redirect_uri_base'];?>',
        scope: '<?=str_replace('+', ' ', $sberbank_auth_params['scope']);?>',
        nonce: '<?=$sberbank_auth_params['nonce'];?>',
        state: '<?=$sberbank_auth_params['state'];?>',
      };
      const sa = {
        enable: true,
        init: 'auto',
        clientId: '<?=$sberbank_auth_params['client_id'];?>',
      };

      let params = {
        baseUrl: 'https://online.sberbank.ru',
        oidc: oidcParams,
        container: '.sber-id-container-<?=$sberbank_auth_params['nonce'];?>',
        display: 'desktop',
        generateState: true,
        onSuccessCallback,
        onErrorCallback,
        sa: sa,
        notification: {
          enable: true,
          onNotificationBannerClose: () => {
              console.log('Баннер закрыт');
          },
          onNotificationBannerOpen: () => {
              console.log('Баннер открыт');
          },
          animation: true,
          position: 'right',
        },
      }

      <?php if($options['button_fast'] == '1') {?>
        params.fastLogin =  {
          changeUser: true,
            enable: true,
            timeout: 2000,
            mode: 'default'
        };
       <?php } ?>

      <?php if($options['button_personal'] == '1') {?>
        params.personalization = true;
        params.changeUser = true;
      <?php } ?>

      <?php if($options['web_to_app'] == '1') {?>
        params.mweb2app = true;
      <?php } ?>

      function onSuccessCallback(result) {
        const params = {
          nonce: oidcParams.nonce,
          code: result.code
        }
        fetch('<?=$sberbank_auth_params['redirect_uri_base'];?>&fast_login=1&' + new URLSearchParams(params)).then(function (response) {
          return response.json();
        }).then(function (params) {
        	console.log(params)
          if(params.auth_status == 1) {
            document.location.href="/";
          }
        });
      }
      function onErrorCallback(result) {
        console.log('Что-то пошло не так: ', result)
      }
      var sbSDK = new SberidSDK(params);
    }());
})
  

</script>
<style>
<? if($button_theme == 'white') { ?>
:root{--sbid-bg-color:#fff;--sbid-bg-color-hover:#fff;--sbid-bg-color-active:#e5e5e5;--sbid-brd-width:1px;--sbid-brd-style:solid;--sbid-brd-radius:4px;--sbid-brd-color:#767676;--sbid-brd-color-hover:#21a038;--sbid-brd-color-active:#21a038;--sbid-text-color:#000;--sbid-fill-color:#21a038;--sbid-font-family:"SB Sans","Roboto","San Francisco",sans-serif;--sbid-font-size:14px;--sbid-font-weight:400}
<? } ?>
<? if($button_size == 'small') { ?>
  :root{--sbid-padding:5px 39px;--sbid-font-size:14px;--sbid-line-height:16px;--sbid-height:28px;--sbid-button-display:inline-flex;--sbid-logo-size:16px}
<? } ?>

<? if($button_size == 'long') { ?>
  :root{--sbid-padding:17px 39px;--sbid-font-size:16px;--sbid-line-height:20px;--sbid-height:56px;--sbid-button-display:inline-flex;--sbid-logo-size:26px}
<? } ?>
:root{
    --sbid-mobile-width:768px
}
</style>
</noindex>

