<?php 

use Joomla\CMS\Factory;



// echo "qqq";


class JFormRuleFile extends JFormRule
{
	public function test(SimpleXMLElement $element, $value, $group = null, JRegistry $input = null, JForm $form = null)
    {
    	if(file_exists(dirname(JPATH_ADMINISTRATOR) . '/plugins/authentication/sber_id/lib/handler.php')) {
			
			require_once dirname(JPATH_ADMINISTRATOR) . '/plugins/authentication/sber_id/lib/handler.php';
			
			$oauth_handler = new Sberbank\Auth\Handler();	
			$oauth_handler->setSertificateDir(dirname(JPATH_ADMINISTRATOR) . '/plugins/authentication/sber_id/sert/');

			$inp = Factory::getApplication()->input;
			
			$files = $inp->files->get('jform');
			if(isset($files['params']['SERTIFICATE_FILE'])) {
				$oauth_handler->sertificate_save($files['params']['SERTIFICATE_FILE']);
				if($oauth_handler->sertificate_crop($_POST['jform']['params']['SERTIFICATE_PASSWORD'])) {
					$element->addAttribute('message', 'Успешно! Сертификат загружен успешно и раскодирован!' );
					return true;
				} else {
					return false;
					$element->addAttribute('message', 'Ошибка, возможно пароль сертификата введен неверено. Укажите верный пароль, и загрузите файл сертификата снова.' );
				}
			}
		} else {
			return false;
			$element->addAttribute('message', 'Ошибка. Переустановите модуль, либо обратитесь в тех. поддержку модуля.' );
		}
        return true;
    }
}

?>
